using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Threading;
using BibliotecaComum;

namespace AmbienteDeDesenvolvimento
{
    public partial class CompilarForm : Form
    {
        Projeto _projeto;

        public CompilarForm(Projeto projeto)
        {
            _projeto = projeto;
            InitializeComponent();
        }

        private string _arquivoExecutavel;

        public string ArquivoExecutavel
        {
            get { return _arquivoExecutavel; }
            set { _arquivoExecutavel = value; }
        }

        private string _retorno;

        public string Retorno
        {
            get { return _retorno; }
            set { _retorno = value; }
        }

        public string Compilacao
        {
            get { return saidaCampo.Text; }
        }


        internal void txtnl(string texto)
        {
            saidaCampo.Text += texto + Environment.NewLine;
            saidaCampo.Select(saidaCampo.Text.Length, 0);
            saidaCampo.ScrollToCaret();
        }

        internal void txt(string texto)
        {
            saidaCampo.Text += texto;
            saidaCampo.Select(saidaCampo.Text.Length, 0);
            saidaCampo.ScrollToCaret();
        }

        private class SaidaCompilacao : ISaidaCompilacao
        {
            private CompilarForm _form;

            public CompilarForm Form
            {
                get { return _form; }
                set { _form = value; }
            }

            public SaidaCompilacao(CompilarForm form)
            {
                _form = form;
            }


            #region ISaidaCompilacao Members

            public void Escrever(string conteudo)
            {
                _form.txt(conteudo);
            }

            public void EscreverNL(string conteudo)
            {
                _form.txtnl(conteudo);
            }

            public void Retorno(string conteudo)
            {
                _form.Retorno += conteudo;
                Escrever(conteudo);
            }

            public void AtualizarInterface()
            {
                Application.DoEvents();
            }

            public void ArquivoExecutavel(string arq)
            {
                _form.ArquivoExecutavel = arq;
            }

            public void Erro(string msg)
            {
                MessageBox.Show(msg);
                _form.Retorno += msg + Environment.NewLine;
                Escrever(msg);
                _form.DialogResult = DialogResult.Abort;
                _form.Close();
            }

            #endregion
        }

        private void CompilarForm_Load(object sender, EventArgs e)
        {
            Text = Traducao.Compilando;
            Retorno = "";
            _projeto.Compilar(new SaidaCompilacao(this), Application.ExecutablePath, Traducao.CompilandoProjeto, Traducao.NaoEncontrado, Config.ASM);
            
            if (Retorno.ToLower().Contains("error"))
            {
                DialogResult = DialogResult.Abort;
            }
            else
            {
                DialogResult = DialogResult.OK;
            }
            Close();
        }
    }
}