using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace AmbienteDeDesenvolvimento
{
    public partial class ConfigForm : Form
    {
        public ConfigForm()
        {
            InitializeComponent();
        }

        private void ConfigForm_Load(object sender, EventArgs e)
        {
            Text = Traducao.Configuracoes;
            montadorRotulo.Text = Traducao.Montador;
            traducaoRotulo.Text = Traducao.TraducaoTexto;
            okBotao.Text = Traducao.Ok;
            cancelarBotao.Text = Traducao.Cancelar;
            foreach(string dir in Directory.GetFiles(Path.GetDirectoryName(Application.ExecutablePath), "*.tra"))
            {
                traducaoCampo.Items.Add(Path.GetFileNameWithoutExtension(Path.GetFileName(dir)));
            }
            carregar();
        }

        private void carregar()
        {
            traducaoCampo.Text = Config.Traducao;
            montadorCampo.Text = Config.ASM;
        }

        private void montadorTinyBotao_Click(object sender, EventArgs e)
        {
            montadorCampo.Text = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "TINYASM.EXE");
        }

        private void montadorBrBotao_Click(object sender, EventArgs e)
        {
            montadorCampo.Text = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "BRASM.EXE");
        }

        private void cancelarBotao_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

        private void okBotao_Click(object sender, EventArgs e)
        {
            Config.ASM = montadorCampo.Text;
            Config.Traducao = traducaoCampo.Text;
            MessageBox.Show(Traducao.AlteracoesReiniciar);
            DialogResult = DialogResult.OK;
            Close();
        }

        private void desfazerBotao_Click(object sender, EventArgs e)
        {
            Config.RedefinirTudo();
            carregar();
        }
    }
}