using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.IO;
using BibliotecaComum;

namespace AmbienteDeDesenvolvimento
{
    public partial class EditorControle : UserControl
    {
        Projeto _projeto;
        string _endereco;
        bool _ignoraAlteracao = true;

        public EditorControle(Projeto projeto, string arquivo)
        {
            _projeto = projeto;
            _endereco = _projeto.Caminho(arquivo);
            InitializeComponent();
        }

        private void EditorControle_Load(object sender, EventArgs e)
        {
            if (File.Exists(_endereco))
            {
                conteudoCampo.Text = File.ReadAllText(_endereco);
                conteudoCampo.Select(0, 0);
                conteudoCampo.ScrollToCaret();
            }
            _ignoraAlteracao = false;
        }

        public void Salvar()
        {
            File.WriteAllText(_endereco, conteudoCampo.Text);
            if (this.Parent is TabPage)
            {
                if (((TabPage)this.Parent).Text.EndsWith("*"))
                {
                    ((TabPage)this.Parent).Text = ((TabPage)this.Parent).Text.Substring(0, ((TabPage)this.Parent).Text.Length - 2);
                }
            }
        }

        private void conteudoCampo_TextChanged(object sender, EventArgs e)
        {
            if (_ignoraAlteracao) return;
            if (this.Parent is TabPage)
            {
                if (!((TabPage)this.Parent).Text.EndsWith("*"))
                {
                    ((TabPage)this.Parent).Text += " *";
                }
            }
        }
    }
}
