using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using BibliotecaComum;

namespace AmbienteDeDesenvolvimento
{
    public partial class NovoProjetoForm : Form
    {
        public NovoProjetoForm()
        {
            InitializeComponent();
        }

        private Projeto _projeto;

        public Projeto Projeto
        {
            get { return _projeto; }
            set { _projeto = value; }
        }


        private void NovoProjetoForm_Load(object sender, EventArgs e)
        {
            Text = Traducao.NovoProjeto;
            tipoGrupo.Text = Traducao.TipoDoProjeto;
            husisOpcao.Text = Traducao.TipoHUSIS;
            dosOpcao.Text = Traducao.TipoDOS;
            binarioSimplesOpcao.Text = Traducao.TipoBinario;
            nomeGrupo.Text = Traducao.NomeDoProjeto;
            diretorioProjetosGrupo.Text = Traducao.DiretorioDosProjetos;
            nomeCampo.Text = Traducao.SemNome;
            okBotao.Text = Traducao.Ok;
            cancelarBotao.Text = Traducao.Cancelar;
            diretorioProjetosCampo.Text = Config.DiretorioProjetos;
            abrirProjetoBotao.Text = Traducao.AbrirProjeto;
        }

        private void cancelarBotao_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

        private void criarDir(string endereco)
        {
            if (!Directory.Exists(Path.GetDirectoryName(endereco)))
            {
                criarDir(Path.GetDirectoryName(endereco));
            }
            if (!Directory.Exists(endereco))
            {
                Directory.CreateDirectory(endereco);
            }
        }

        private void okBotao_Click(object sender, EventArgs e)
        {
            if (!husisOpcao.Checked & !dosOpcao.Checked & !binarioSimplesOpcao.Checked)
            {
                MessageBox.Show(Traducao.InformeTipo);
                return;
            }
            string endereco = Path.Combine(diretorioProjetosCampo.Text, nomeCampo.Text);
            criarDir(endereco);
            Projeto = new Projeto(endereco);
            if (Projeto.Existia)
            {
                MessageBox.Show(Traducao.JaExiste);
                return;
            }
            Projeto.Nome = nomeCampo.Text;
            Projeto.TipoBinario = binarioSimplesOpcao.Checked;
            Projeto.TipoBinarioDOS = dosOpcao.Checked;
            Projeto.TipoHusis = husisOpcao.Checked;
            Config.DiretorioProjetos = diretorioProjetosCampo.Text;
            string conteudo = Traducao.InicialNomeRotina + ":" + Environment.NewLine +
                "\tretf";
            if (!File.Exists(_projeto.Caminho(Traducao.PrincipalNomeArq))) File.WriteAllText(Projeto.Caminho(Traducao.PrincipalNomeArq), conteudo);
            Projeto.Adicionar(Traducao.PrincipalNomeArq, AcaoArquivo.CompilarAssembly);
            Projeto.ArquivoPrincipal = Traducao.PrincipalNomeArq;
            Projeto.RotinaInicial = Traducao.InicialNomeRotina;
            Projeto.Salvar();
            DialogResult = DialogResult.OK;
            Close();
        }

        private void diretorioProjetosBotao_Click(object sender, EventArgs e)
        {
            diretorioProjetosJanela.SelectedPath = diretorioProjetosCampo.Text;
            if (diretorioProjetosJanela.ShowDialog() == DialogResult.OK)
            {
                diretorioProjetosCampo.Text = diretorioProjetosJanela.SelectedPath;
            }
        }

        private void abrirProjetoBotao_Click(object sender, EventArgs e)
        {
            diretorioProjetosJanela.SelectedPath = Config.UltimoProjeto;
            if (diretorioProjetosJanela.ShowDialog() == DialogResult.OK)
            {
                Projeto = new Projeto(diretorioProjetosJanela.SelectedPath);
                if (!Projeto.Existia)
                {
                    MessageBox.Show(Traducao.NaoExiste);
                    return;
                }
                DialogResult = DialogResult.OK;
                Close();
            }

        }
    }
}