using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using BibliotecaComum;

namespace AmbienteDeDesenvolvimento
{
    public partial class ProjetoControle : UserControl
    {
        Projeto _projeto;
        bool ignoraAlteracao = true;

        public ProjetoControle(Projeto projeto)
        {
            _projeto = projeto;
            InitializeComponent();
        }

        private void ProjetoControle_Load(object sender, EventArgs e)
        {
            nomeRotulo.Text = Traducao.NomeDoProjeto;
            tipoRotulo.Text = Traducao.TipoDoProjeto;
            husisOpcao.Text = Traducao.TipoHUSIS;
            dosOpcao.Text = Traducao.TipoDOS;
            binarioSimplesOpcao.Text = Traducao.TipoBinario;
            rotinaInicialRotulo.Text = Traducao.RotinaInicial;
            arquivoPrincipalRotulo.Text = Traducao.ArquivoPrincipal;
            projetoFonte.DataSource = _projeto;
            ignoraAlteracao = false;
        }

        public void Salvar()
        {
            ignoraAlteracao = true;
            projetoFonte.EndEdit();
            _projeto.Salvar();
            if (this.Parent is TabPage)
            {
                if (((TabPage)this.Parent).Text.EndsWith("*"))
                {
                    ((TabPage)this.Parent).Text = ((TabPage)this.Parent).Text.Substring(0, ((TabPage)this.Parent).Text.Length - 2);
                }
            }
            ignoraAlteracao = false;
        }

        private void projetoFonte_CurrentItemChanged(object sender, EventArgs e)
        {
            if (ignoraAlteracao) return;
            if (this.Parent is TabPage)
            {
                if (!((TabPage)this.Parent).Text.EndsWith("*"))
                {
                    ((TabPage)this.Parent).Text += " *";
                }
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            //projetoFonte.EndEdit();
            //projetoFonte.ResetBindings(false);
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            //projetoFonte.EndEdit();
            //projetoFonte.ResetBindings(false);
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            //projetoFonte.EndEdit();
            //projetoFonte.ResetBindings(false);
        }
    }
}
