using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using BibliotecaComum;

namespace AmbienteDeDesenvolvimento
{
    class Traducao
    {
        static ArquivoIni _ini = null;

        public static void Iniciar(string lingua)
        {
            _ini = new ArquivoIni(Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), lingua + ".tra"));
        }

        private static string trad(string chavePadrao)
        {
            return _ini.Ler("TRAD", chavePadrao, chavePadrao);
        }

        private static string trad(string chave, string padrao)
        {
            return _ini.Ler("TRAD", chave, padrao);
        }

        public static string Compilar
        {
            get
            {
                return trad("Compilar");
            }
        }

        public static string Distribuir
        {
            get
            {
                return trad("Distribuir");
            }
        }

        public static string Publicar
        {
            get
            {
                return trad("Publicar");
            }
        }

        public static string Importar
        {
            get
            {
                return trad("Importar");
            }
        }

        public static string Excluir
        {
            get
            {
                return trad("Excluir");
            }
        }

        public static string Salvar
        {
            get
            {
                return trad("Salvar");
            }
        }

        public static string AbrirProjeto
        {
            get
            {
                return trad("AbrirProjeto", "Abrir Projeto");
            }
        }

        public static string Novo
        {
            get
            {
                return trad("Novo");
            }
        }

        public static string NovoProjeto
        {
            get
            {
                return trad("NovoProjeto", "Novo Projeto");
            }
        }

        public static string NovoArquivoAssembly
        {
            get
            {
                return trad("NovoArquivoAssembly","Novo Arquivo Assembly");
            }
        }

        public static string NovaTraducao
        {
            get
            {
                return trad("NovaTraducao", "Nova Traduo");
            }
        }

        public static string FecharAba
        {
            get
            {
                return trad("FecharAba", "Fechar Aba");
            }
        }

        public static string Erros
        {
            get
            {
                return trad("Erros", "Erros");
            }
        }

        public static string UltimaCompilacao
        {
            get
            {
                return trad("UltimaCompilacao", "ltima Compilao");
            }
        }

        public static string Projeto
        {
            get
            {
                return trad("Projeto");
            }
        }

        public static string NovoArquivoAssemblyTexto
        {
            get
            {
                return trad("NovoArquivoAssemblyTexto", "Informe o nome do arquivo: (Salvar quaisquer alterao no projeto)");
            }
        }

        public static string Ok
        {
            get
            {
                return trad("Ok");
            }
        }

        public static string Cancelar
        {
            get
            {
                return trad("Cancelar");
            }
        }

        public static string Compilando
        {
            get
            {
                return trad("Compilando", "Compilando . . .");
            }
        }

        public static string NaoEncontrado
        {
            get
            {
                return trad("NaoEncontrado", "'%s' no encontrado.");
            }
        }

        public static string CompilandoProjeto
        {
            get
            {
                return trad("CompilandoProjeto", "Compilando projeto: ");
            }
        }

        public static string NomeDoProjeto
        {
            get
            {
                return trad("NomeDoProjeto", "Nome do Projeto");
            }
        }

        public static string TipoDoProjeto
        {
            get
            {
                return trad("TipoDoProjeto", "Tipo do Projeto");
            }
        }

        public static string TipoHUSIS
        {
            get
            {
                return trad("TipoHUSIS", "Projeto HUSIS 86");
            }
        }

        public static string TipoDOS
        {
            get
            {
                return trad("TipoDOS", "Projeto DOS");
            }
        }

        public static string TipoBinario
        {
            get
            {
                return trad("TipoBinario", "Binrio Simples");
            }
        }

        public static string RotinaInicial
        {
            get
            {
                return trad("RotinaInicial", "Rotina inicial (Programa HUSIS 86 ou DOS)");
            }
        }

        public static string ArquivoPrincipal
        {
            get
            {
                return trad("ArquivoPrincipal", "Arquivo Principal (Binrio Simples)");
            }
        }

        public static string Configuracoes
        {
            get
            {
                return trad("Configuracoes", "Configuraes");
            }
        }

        public static string Montador
        {
            get
            {
                return trad("Montador", "Montador:");
            }
        }

        public static string TraducaoTexto
        {
            get
            {
                return trad("Traducao", "Traduo:");
            }
        }

        public static string AlteracoesReiniciar
        {
            get
            {
                return trad("AlteracoesReiniciar", "Reinicie o Ambiente de Desenvolvimento para carregar as novas configuraes");
            }
        }

        public static string DiretorioDosProjetos
        {
            get
            {
                return trad("DiretorioDosProjetos", "Diretrio dos Projetos:");
            }
        }

        public static string SemNome
        {
            get
            {
                return trad("SemNome", "Sem Nome");
            }
        }

        public static string InformeTipo
        {
            get
            {
                return trad("InformeTipo", "Informe o tipo do projeto");
            }
        }

        public static string PrincipalNomeArq
        {
            get
            {
                return trad("PrincipalNomeArq", "Principal.s");
            }
        }

        public static string InicialNomeRotina
        {
            get
            {
                return trad("InicialNomeRotina", "Inicial");
            }
        }

        public static string JaExiste
        {
            get
            {
                return trad("JaExiste", "Projeto j existe no local");
            }
        }

        public static string NaoExiste
        {
            get
            {
                return trad("NaoExiste", "Projeto no existe no local");
            }
        }

        public static string NaoFoiPossivelRemover
        {
            get
            {
                return trad("NaoFoiPossivelRemover", "No  possvel remover o arquivo do projeto");
            }
        }

        public static string ConfirmaExclusao
        {
            get
            {
                return trad("ConfirmaExclusao", "Confirma a excluso do arquivo '{0}'?");
            }
        }
    }
}
