using System;
using System.Collections.Generic;
using System.Text;
using BibliotecaComum;
using System.IO;
using System.Globalization;

namespace Compilar
{
    class Config
    {
        static ArquivoIni _ini = null;
        static string _cfg = null;
        static string _exeEndereco = null;
        private static bool _novoArqConfig;

        public static bool NovoArqConfig
        {
            get { return _novoArqConfig; }
        }

        public static string EnderecoCfg
        {
            get
            {
                return _cfg;
            }
        }


        public static void Iniciar(string exeEndereco)
        {
            _exeEndereco = exeEndereco;
            string cfg = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "hcadd.cfg");
            _cfg = cfg;
            _novoArqConfig = File.Exists(cfg);
            _ini = new ArquivoIni(cfg);
        }

        public static void RedefinirTudo()
        {
            string cfg = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "hcadd.cfg");
            if (File.Exists(cfg)) File.Delete(cfg);
            Iniciar(_exeEndereco);
        }

        public static string DiretorioProjetos
        {
            get
            {
                return _ini.Ler("AmbienteDeDesenvolvimento", "DiretorioProjetos", Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments));
            }
            set
            {
                _ini.Gravar("AmbienteDeDesenvolvimento", "DiretorioProjetos", value);
            }
        }

        public static string ASM
        {
            get
            {
                return _ini.Ler("ASM", "EXE", Path.Combine(Path.GetDirectoryName(_exeEndereco), "BRASM.EXE"));
            }
            set
            {
                _ini.Gravar("ASM", "EXE", value);
                _ini.SalvarArquivo();
            }
        }

        public static string Traducao
        {
            get
            {
                return _ini.Ler("AmbienteDeDesenvolvimento", "Traducao", CultureInfo.CurrentUICulture.TwoLetterISOLanguageName.ToUpper() + RegionInfo.CurrentRegion.TwoLetterISORegionName.ToUpper());
            }
            set
            {
                _ini.Gravar("AmbienteDeDesenvolvimento", "Traducao", value);
                _ini.SalvarArquivo();
            }
        }

        public static string UltimoProjeto
        {
            get
            {
                return _ini.Ler("AmbienteDeDesenvolvimento", "UltimoProjeto", "");
            }
            set
            {
                _ini.Gravar("AmbienteDeDesenvolvimento", "UltimoProjeto", value);
                _ini.SalvarArquivo();
            }
        }
    }
}
