using System;
using System.Collections.Generic;
using System.Text;
using BibliotecaComum;
using System.IO;

namespace Compilar
{
    class Program
    {
        class SaidaCompilacao : ISaidaCompilacao
        {
            #region ISaidaCompilacao Members

            public void Escrever(string txt)
            {
                Console.Write(txt);
            }

            public void EscreverNL(string txt)
            {
                Console.WriteLine(txt);
            }

            public void Retorno(string txt)
            {
                Console.Error.Write(txt);
            }

            public void AtualizarInterface()
            {
                
            }

            public void ArquivoExecutavel(string arq)
            {
                
            }

            public void Erro(string msg)
            {
                Console.Error.WriteLine(msg);
            }

            #endregion
        }

        static void Main(string[] args)
        {
            string enderecoExe = System.Reflection.Assembly.GetExecutingAssembly().Location;
            Config.Iniciar(enderecoExe);
            Console.WriteLine("Config: " + Config.EnderecoCfg);
            bool pausa = false;
            if (args.Length == 2 && args[1] == "/PAUSA")
            {
                pausa = true;
            }
            else if (args.Length != 1)
            {
                Console.WriteLine("Modo de Uso: Compilar [Diretrio do projeto] [/PAUSA]");
                Console.WriteLine("Usage: Compilar [Project's Path] [/PAUSA]");
                goto fim;
            }
            string end = args[0];
            if (File.Exists(end)) end = Path.GetDirectoryName(end);
            Projeto proj = new Projeto(end);
            if (!proj.Existia)
            {
                Console.Error.WriteLine("Projeto no encontrado.");
                Console.Error.WriteLine("Project not found.");
                goto fim;
            }
            proj.Compilar(new SaidaCompilacao(), enderecoExe, "Compilando Projeto / Building Project : ", "No encontrado {0} / Not found {0}", Config.ASM);
            fim:
            if (pausa)
            {
                while (Console.KeyAvailable)
                {
                    Console.ReadKey();
                }
                Console.WriteLine("Pressione uma tecla para encerrar / Press any key to exit");
                Console.ReadKey();
            }
        }
    }
}
