using System;
using System.Collections.Generic;
using System.Text;

namespace Roteador
{
    class EnderecoHCCom
    {
        public EnderecoHCCom(byte rede, byte local, byte interna)
        {
            Rede = rede;
            Local = local;
            Interna = interna;
        }

        public EnderecoHCCom(string endereco)
        {
            int pos = 0;
            for (; pos < endereco.Length; pos++)
            {
                if (endereco[pos] == '.')
                {
                    break;
                }
                Rede *= 10;
                Rede += byte.Parse(endereco[pos] + "");
            }
            if (endereco[pos] != '.') throw new FormatException("Esperado formato X.X.X");
            pos++;
            for (; pos < endereco.Length; pos++)
            {
                if (endereco[pos] == '.')
                {
                    break;
                }
                Local *= 10;
                Local += byte.Parse(endereco[pos] + "");
            }
            if (endereco[pos] != '.') throw new FormatException("Esperado formato X.X.X");
            pos++;
            for (; pos < endereco.Length; pos++)
            {
                Interna *= 10;
                Interna += byte.Parse(endereco[pos] + "");
            }
            if (pos < endereco.Length) throw new FormatException("Esperado formato X.X.X");
        }

        public EnderecoHCCom()
        {
        }

        public override string ToString()
        {
            return Rede.ToString().Trim() + "." + Local.ToString().Trim() + "." + Interna.ToString().Trim();
        }

        private byte _rede = 0;

        public byte Rede
        {
            get { return _rede; }
            set { _rede = value; }
        }

        private byte _local = 0;

        public byte Local
        {
            get { return _local; }
            set { _local = value; }
        }

        private byte _interna = 0;

        public byte Interna
        {
            get { return _interna; }
            set { _interna = value; }
        }

        public void GravarEm(Fluxo fluxo)
        {
            fluxo.Byte(Rede);
            fluxo.Byte(Local);
            fluxo.Byte(Interna);
        }

        public void LerDe(Fluxo fluxo)
        {
            Rede = fluxo.Byte();
            Local = fluxo.Byte();
            Interna = fluxo.Byte();
        }
    }
}
