using System;
using System.Collections.Generic;
using System.Text;

namespace Roteador
{
    class Fluxo
    {
        public Fluxo()
        {
            _pacote = null;
        }

        public Fluxo(PacoteBase pacote)
        {
            _pacote = pacote;
        }

        private PacoteBase _pacote;

        public PacoteBase Pacote
        {
            get { return _pacote; }
            set { _pacote = value; }
        }

        private int _posicao = 0;

        public int Posicao
        {
            get { return _posicao; }
            set { _posicao = value; }
        }

        public bool Fim
        {
            get
            {
                return Posicao >= Pacote.Tamanho;
            }
        }

        public int Falta
        {
            get
            {
                return Pacote.Tamanho - Posicao;
            }
        }

        public byte Byte()
        {
            byte ret = _pacote.Byte(Posicao);
            Posicao++;
            return ret;
        }

        public void Byte(byte valor)
        {
            _pacote.Byte(Posicao, valor);
            Posicao++;
        }

        public byte[] Bytes(int qtd)
        {
            byte[] ret = _pacote.Bytes(Posicao, qtd);
            Posicao += qtd;
            return ret;
        }

        public void Bytes(byte[] valor)
        {
            _pacote.Bytes(Posicao, valor.Length, valor);
            Posicao += valor.Length;
        }

        public short Short()
        {
            short ret = _pacote.Short(Posicao);
            Posicao += 2;
            return ret;
        }

        public void Short(short valor)
        {
            _pacote.Short(Posicao, valor);
            Posicao += 2;
        }

        public int Int()
        {
            int ret = _pacote.Int(Posicao);
            Posicao += 4;
            return ret;
        }

        public void Int(int valor)
        {
            _pacote.Int(Posicao, valor);
            Posicao += 4;
        }

        public ushort UShort()
        {
            ushort ret = _pacote.UShort(Posicao);
            Posicao += 2;
            return ret;
        }

        public void UShort(ushort valor)
        {
            _pacote.UShort(Posicao, valor);
            Posicao += 2;
        }

        public uint UInt()
        {
            uint ret = _pacote.UInt(Posicao);
            Posicao += 4;
            return ret;
        }

        public void UInt(uint valor)
        {
            _pacote.UInt(Posicao, valor);
            Posicao += 4;
        }

    }
}
