using System;
using System.Collections.Generic;
using System.Text;

namespace Roteador
{
    public abstract class PacoteBase
    {
        private byte[] _dados;

        public byte[] Dados
        {
            get { return _dados; }
            set { _dados = value; }
        }

        public int Tamanho
        {
            get
            {
                return _dados.Length;
            }
        }

        public abstract PacoteSimples ExportarPacoteSimples();

        public abstract void ImportarPacoteSimples(PacoteSimples pacote);

        public byte Byte(int pos)
        {
            return _dados[pos];
        }

        public void Byte(int pos, byte valor)
        {
            _dados[pos] = valor;
        }

        public byte[] Bytes(int pos, int qtd)
        {
            byte[] tmp = new byte[qtd];
            Array.Copy(_dados, pos, tmp, 0, qtd);
            return tmp;
        }

        public void Bytes(int pos, int qtd, byte[] origem)
        {
            Array.Copy(origem, 0, _dados, 0, qtd);
        }

        public short Short(int pos)
        {
            return BitConverter.ToInt16(Bytes(pos, 2), 0);
        }

        public void Short(int pos, short valor)
        {
            Bytes(pos, 2, BitConverter.GetBytes(valor));
        }

        public int Int(int pos)
        {
            return BitConverter.ToInt32(Bytes(pos, 4), 0);
        }

        public void Int(int pos, int valor)
        {
            Bytes(pos, 4, BitConverter.GetBytes(valor));
        }

        public ushort UShort(int pos)
        {
            return BitConverter.ToUInt16(Bytes(pos, 2), 0);
        }

        public void UShort(int pos, ushort valor)
        {
            Bytes(pos, 2, BitConverter.GetBytes(valor));
        }

        public uint UInt(int pos)
        {
            return BitConverter.ToUInt32(Bytes(pos, 4), 0);
        }

        public void UInt(int pos, uint valor)
        {
            Bytes(pos, 4, BitConverter.GetBytes(valor));
        }
    }
}
