using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using BibliotecaComum;
using System.IO.Ports;

namespace Roteador
{
    class Program
    {
        static string _enderecoDir;
        static string _enderecoCfg;
        static ArquivoIni _config;

        static void Main(string[] args)
        {
            Console.WriteLine("HCCOM - Roteador");
            _enderecoDir = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "hccom");
            Console.WriteLine("Diretrio de Configurao: " + _enderecoDir);
            if (!Directory.Exists(_enderecoDir)) Directory.CreateDirectory(_enderecoDir);
            _enderecoCfg = Path.Combine(_enderecoDir, "roteador.cfg");
            carregarConfig();
            PacoteHCCom pac = new PacoteHCCom("0.0.255", "0.0.0",  PortasHCCom.SolicitaEndereco, 0, 0, 0, new byte[]{1,2,3});
            PacoteHCCom pac2 = new PacoteHCCom(pac.ExportarPacoteSimples());
            Console.ReadLine();
        }

        static string lerConex(int conexao, string config, string valorPadrao)
        {
            return _config.Ler("Conexo " + conexao.ToString().Trim(), config, valorPadrao);
        }

        static int lerConexInt(int conexao, string config, string valorPadrao)
        {
            return Convert.ToInt32(_config.Ler("Conexo " + conexao.ToString().Trim(), config, valorPadrao));
        }

        static void iniciaSerial(int conexao)
        {
            string porta = lerConex(conexao, "Porta", "");
            int velocidade = lerConexInt(conexao, "Velocidade", "0");
            SerialPort sp = new SerialPort(porta, velocidade, Parity.None, 8, StopBits.One);
            sp.Open();

        }

        static void iniciaEthernet(int conexao)
        {

        }

        static void carregarConfig()
        {
            Console.WriteLine("Carregando configurao: " + _enderecoCfg);
            _config = new ArquivoIni(_enderecoCfg);
            for (int i = 0; i < 16; i++)
            {
                string tipo = lerConex(i, "Tipo", "");
                if(tipo != "")
                {
                    Console.WriteLine("Configurando Conexo " + i.ToString().Trim());
                    switch (tipo)
                    {
                        case "cliente":
                            break;
                        case "ethernet":
                            break;
                        case "servidor":
                            break;
                        case "serial":
                            iniciaSerial(i);
                            break;
                        default:
                            break;
                    }
                }
            }
        }

        static void _monitorConfig_Created(object sender, FileSystemEventArgs e)
        {
            carregarConfig();
        }

        static void _monitorConfig_Changed(object sender, FileSystemEventArgs e)
        {
            carregarConfig();
        }
    }
}
